#include <stdio.h>
#include <stdlib.h>
#include "codage_par_plage.h"

int main( int argc, char** argv ) {
    if (argc != 2) {
        fprintf(stderr, "Usage : %s u0\n", argv[0]);
        exit(EXIT_FAILURE);
    }
    int u0 = atoi(argv[1]);
    char* s1000 = s(u0, 1000);
    char* s100000 = s(u0, 100000);
    char* s12000 = s(u0, 12000);
    pile* code_s1000 = codage_chaine(s1000);
    pile* code_s12000 = codage_chaine(s12000);
    pile* code_s100000 = codage_chaine(s100000);
    printf("Question 4 : a) %i  b) %i  c) %i\n",
           code_s1000->nb_maillon,
           code_s12000->nb_maillon,
           code_s100000->nb_maillon);

    char* s212x212 = s(u0, 212*212);
    char* s512x512 = s(u0, 512*512);
    char* s1000x1000 = s(u0, 1000*1000);
    image* img212x212 = i(s212x212,212);
    image* img512x512 = i(s512x512,512);
    image* img1000x1000 = i(s1000x1000,1000);
    printf("Question 8 : a) %i  b) %i  c) %i\n",
           plus_grand_carre_blanc(img212x212),
           plus_grand_carre_blanc(img512x512),
           plus_grand_carre_blanc(img1000x1000));
    uint* code212x212 = codage_image(img212x212);
    uint* code512x512 = codage_image(img512x512);
    uint* code1000x1000 = codage_image(img1000x1000);
    printf("Question 11 : a) %ld%%  b) %ld%%  c) %ld\%%\n",
           100 - ((code212x212[0]*3+3) * sizeof(uint) * 100) / (212*212*sizeof(char)) ,
           100 - ((code512x512[0]*3+3) * sizeof(uint) * 100) / (512*512*sizeof(char)) ,
           100 - ((code1000x1000[0]*3+3) * sizeof(uint) * 100) / (1000*1000*sizeof(char)) );

    free(s1000);
    free(s100000);
    free(s12000);
    detruire_pile(code_s1000);
    detruire_pile(code_s12000);
    detruire_pile(code_s100000);
    free(s212x212);
    free(s512x512);
    free(s1000x1000);
    detruire_image(img212x212);
    detruire_image(img512x512);
    detruire_image(img1000x1000);
    free(code212x212);
    free(code512x512);
    free(code1000x1000);

    return EXIT_SUCCESS;
}
