#ifndef CODAGE_PAR_PLAGE_H
#define CODAGE_PAR_PLAGE_H
#include <stdbool.h>

typedef unsigned int uint;

typedef struct maillon {
    char caractere;
    uint repetition;
    struct maillon* suivant;
} maillon;

typedef struct pile {
    maillon* sommet;
    uint taille;
    uint nb_maillon;
} pile;

typedef struct image {
    char** pixels;
    uint largeur;
    uint hauteur;
} image;

pile* creer_pile_vide();
void detruire_pile(pile*);
void empiler(pile*, char);
char depiler(pile*);
pile* codage_chaine(char*);
char* decodage_chaine(pile*);
char* s(uint, uint);
void print_chaine_encodee(pile*);
image* creer_image_noire(uint, uint);
void detruire_image(image*);
uint plus_grand_carre_blanc(image*);
uint* codage_image(image*);
image* decodage_image(uint*);
image* i(char*, uint);

#endif
